--SOC
sfxinfo[sfx_s22b].caption = "Air jump"

--Resetando a porra toda
local function fuckGoBack(p)
	if p.valid and p.mo.valid
		p.suddenStop = false
		p.prevthokked = nil
		p.pmomz = 0
		p.pflags = $ & ~PF_STASIS
		p.jomp = false
		p.jompTimer = 0
		p.squish = false
		p.afterSquish = false
		p.mo.spritexscale = FRACUNIT
		p.mo.spriteyscale = FRACUNIT
	end
end

--Clamp. Limita valores
local function clamp(val, minv, maxv)
	return min(max(val, minv), maxv)
end

addHook("ThinkFrame", function()
	for p in players.iterate
		
		--Mudamos de personagem durante uma distorção ou comando. Volte ao normal.
		if p.mo and ( p.jomp or p.jompTimer or p.squish or p.afterSquish ) and not (p.mo.skin == "abacaxonic")
			fuckGoBack(p)
		end
		if p.mo and p.mo.skin == "abacaxonic"
			--Só pode se mexer no ar
			if P_IsObjectOnGround(p.mo) and not srb2p
				p.pflags = $ | PF_STASIS
			else
				p.pflags = $ & ~PF_STASIS
			end
			
			--Abacaxi desliza, é claro. não questione, só aceite.
			p.mo.friction = 30*FRACUNIT/32
			
			--Pode usar thok mesmo saindo de uma mola, e usar uma mola inicia a distorção de pulo
			if p.mo.eflags & MFE_SPRUNG
				fuckGoBack(p)
				p.pflags = $ | PF_JUMPED
			end
			
			--Distorções sempre ocorrem no ar, independente do que nos fez ir pra cima
			if not P_IsObjectOnGround(p.mo)
				p.jompDistort = true
			end
			
			--Início de pulo com delay e distorção
			if(p.jompTimer and p.jompTimer < 10)
				p.jompTimer = $+1
				p.mo.spritexscale = $+(FRACUNIT/25)
				p.mo.spriteyscale = $-(FRACUNIT/25)
				if(p.jompTimer == 10)
					p.jomp = false
					if not P_IsObjectOnGround(p.mo)
						S_StartSound(p.mo, sfx_s22b)
						P_SpawnMobjFromMobj(p.mo, 0,0,0, MT_ABACACIRC)
					end
					P_DoJump(p)
				end
			end
			
			--Distorção do pulo, aka MATEMÁTICA DE SHITPOST AEHOOOOO
			if(p.jompDistort and not (maptol & TOL_NIGHTS))
			
				--Variáveis de fácil acesso para serem modificadas
				local distortScale = 25
				local fracsForDistortion = 25*FRACUNIT
				local floorDist = abs(p.mo.floorz - p.mo.z)
				local fracBullshit = clamp(floorDist, 0, fracsForDistortion)/(fracsForDistortion/FRACUNIT)
				
				-- M a t e m á t i c a  abaixo
				
				--Aqui checamos se o jogador teve uma "parada súbita" ao soltar o botão de pulo durante sua ascensão
				if abs(p.mo.momz - p.pmomz) >= 2*FRACUNIT and not (P_IsObjectOnGround(p.mo)) and not (p.pflags & PF_THOKKED) and not(p.prevthokked)
					p.suddenStop = true
				end
				
				--Caso o não haja nenhuma parada súbita realizamos o cálculo normal de squash & stretch
				if not p.suddenStop
					--Aqui usamos duas coisas para calcular a distorção:
						--Primeiro: a velocidade vertical do jogador
						--Segundo: sua distância do chão
					--Um jogador deve sempre retornar a sua deformação padrão de FRACUNIT quando próximo ao chão
					--Assim sendo, usamos um multiplicador de FRACUNIT que vai de 0*FRACUNIT até 1*FRACUNIT, baseado na altura do jogador
					--Para impedir distorções exageradas usamos uma função de clamp (vide começo do arquivo lua)
					if abs(p.mo.momz)/FRACUNIT >= 1
						p.mo.spritexscale = FRACUNIT - clamp(( FixedMul((abs(p.mo.momz)/distortScale), fracBullshit) ), 0, FRACUNIT/3)
						p.mo.spriteyscale = FRACUNIT + clamp(( FixedMul((abs(p.mo.momz)/distortScale), fracBullshit) ), 0, 3*FRACUNIT/4)
					end
				--Caso haja uma parada súbita...
				else
					--...checamos se essa parada não vou causada por um thok...
					if p.pflags & PF_THOKKED
						p.suddenStop = false
					end
					--...e então "freamos" o jogador até seu spritescale normal de FRACUNIT
					p.mo.spritexscale = $ - (abs($)-FRACUNIT)/8
					p.mo.spriteyscale = $ - (abs($)-FRACUNIT)/8
					if p.mo.spritexscale > 95*FRACUNIT/100 and p.mo.spritexscale < 105*FRACUNIT/100
						p.mo.spritexscale = FRACUNIT
						p.mo.spriteyscale = FRACUNIT
						--Após esse freio retornamos ao cálculo normal de distorção
						p.suddenStop = false
					end
				end
			end
			
			--Caímos após uma distorção. Vamos para a distorção de queda
			if(p.jompDistort and P_IsObjectOnGround(p.mo))
				S_StartSound(p.mo, sfx_wdrip8)
				p.mo.spritexscale = FRACUNIT
				p.mo.spriteyscale = FRACUNIT
				p.jompDistort = false
				p.squish = true
			end
			
			--Distorção de queda
			if(p.squish or p.afterSquish)
				if(p.squish)
					p.mo.spritexscale = $+(FRACUNIT/25)
					p.mo.spriteyscale = $-(FRACUNIT/25)
					if p.mo.spritexscale >= FRACUNIT+(FRACUNIT/4)
						p.squish = false
						p.afterSquish = true
					end
				end
				if(p.afterSquish)
					p.mo.spritexscale = $ - (abs($)-FRACUNIT)/5
					p.mo.spriteyscale = $ - (abs($)-FRACUNIT)/5
					if p.mo.spritexscale > 95*FRACUNIT/100 and p.mo.spritexscale < 105*FRACUNIT/100
						p.mo.spritexscale = FRACUNIT
						p.mo.spriteyscale = FRACUNIT
						p.afterSquish = false
					end
				end
			end
			
			--Guardando momz do tic atual para ser usado como referência no próximo, assim como o flag thoked
			--Ambos usados em ||p.jompDistort||
			p.prevthokked = p.pflags & PF_THOKKED
			p.pmomz = p.mo.momz
			
		end
	end
end)

--Delay ao apertar pulo no chão. Ignorado no ar para realizarmos nosso thok.
addHook("JumpSpecial", function(p)
	if not p.mo or not (p.mo.skin == "abacaxonic") then return end
		if(P_IsObjectOnGround(p.mo) and (p.jomp == nil or p.jomp == false))
			if(p.jomp == nil or p.jomp == false)
				p.squish = false
				p.afterSquish = false
				p.mo.spritexscale = FRACUNIT
				p.mo.spriteyscale = FRACUNIT
				p.jomp = true
				p.jompTimer = 1
			end
		end
		if not P_IsObjectOnGround(p.mo) then return end
	return true
end)

--Removendo distorções e variáveis em respawn, dano, morte e troca de mapas
addHook("PlayerSpawn", function(p)
	if p.valid and p.mo.skin == "abacaxonic"
		fuckGoBack(p)
	end
end)
addHook("MapLoad", function(mapnum)
	for p in players.iterate
		if p.valid and p.mo.skin == "abacaxonic"
			fuckGoBack(p)
		end
	end
end)
addHook("MobjDeath", function(mo, inflictor, source, damagetype)
	if not mo.valid then return end
	if mo.skin and mo.skin == "abacaxonic" and mo.p
		fuckGoBack(mo.player)
	end
end, MT_PLAYER)
addHook("MobjDamage", function(mo, inflictor, source, damage, damagetype)
	if not mo.valid then return end
	if mo.skin and mo.skin == "abacaxonic"
		fuckGoBack(mo.player)
	end
end, MT_PLAYER)