
--Thinkers de objetos

--SOC
freeslot("MT_ABACATHOK", "MT_ABACACIRC")

--Abacathok
--define para que direção o abacaxi vai rodar quando for criado
addHook("MobjSpawn", function(mo)
	if(leveltime%2)
		mo.rollto = ANG10
	else
		mo.rollto = -ANG10
	end
end, MT_ABACATHOK)

--roda e diminui o tamanho do abacaxi progressivamente
addHook("MobjThinker", function(mo)
	mo.rollangle = $ + mo.rollto
	mo.spritexscale = $ - $/10
	mo.spriteyscale = $ - $/10
end, MT_ABACATHOK)

--Abacacirculo
--Diminui o tamanho do círculo até quase 0 ao spawnar
addHook("MobjSpawn", function(mo)
	mo.spritexscale = 1
	mo.spriteyscale = 1
end, MT_ABACACIRC)

--Abaixa a altura e aumenta o tamanho do círculo
addHook("MobjThinker", function(mo)
	mo.z = $ - 4*FRACUNIT
	mo.spritexscale = $ + FRACUNIT/5
	mo.spriteyscale = $ + FRACUNIT/5
end, MT_ABACACIRC)